Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWProblemInstance.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWProblemInstance.cs	(revision 17710)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/CVRP/CVRPTW/CVRPTWProblemInstance.cs	(revision 17711)
@@ -23,11 +23,9 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
-using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Problems.VehicleRouting.Interfaces;
 using HeuristicLab.Problems.VehicleRouting.Variants;
@@ -89,19 +87,198 @@
     }
 
-    protected override IEnumerable<IOperator> GetOperators() {
-      return base.GetOperators()
-        .Where(o => o is ITimeWindowedOperator).Cast<IOperator>();
-    }
-
-    protected override IEnumerable<IOperator> GetAnalyzers() {
-      return ApplicationManager.Manager.GetInstances<ITimeWindowedOperator>()
-        .Where(o => o is IAnalyzer)
-        .Cast<IOperator>().Union(base.GetAnalyzers());
-    }
-
-    protected override IVRPEvaluator Evaluator {
-      get {
-        return new CVRPTWEvaluator();
-      }
+    public override IEnumerable<IOperator> FilterOperators(IEnumerable<IOperator> operators) {
+      return base.FilterOperators(operators).Where(x => x is ITimeWindowedOperator);
+    }
+
+    protected override VRPEvaluation CreateTourEvaluation() {
+      return new CVRPTWEvaluation();
+    }
+
+    protected override void EvaluateTour(VRPEvaluation eval, Tour tour, IVRPEncodedSolution solution) {
+      TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
+      eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
+      double originalQuality = eval.Quality;
+
+      double time = 0.0;
+      double waitingTime = 0.0;
+      double serviceTime = 0.0;
+      double tardiness = 0.0;
+      double delivered = 0.0;
+      double overweight = 0.0;
+      double distance = 0.0;
+
+      double capacity = Capacity.Value;
+      for (int i = 0; i <= tour.Stops.Count; i++) {
+        int end = 0;
+        if (i < tour.Stops.Count)
+          end = tour.Stops[i];
+
+        delivered += Demand[end];
+      }
+
+      double spareCapacity = capacity - delivered;
+
+      double tourStartTime = ReadyTime[0];
+      time = tourStartTime;
+
+      //simulate a tour, start and end at depot
+      for (int i = 0; i <= tour.Stops.Count; i++) {
+        int start = 0;
+        if (i > 0)
+          start = tour.Stops[i - 1];
+        int end = 0;
+        if (i < tour.Stops.Count)
+          end = tour.Stops[i];
+
+        //drive there
+        double currentDistace = GetDistance(start, end, solution);
+        time += currentDistace;
+        distance += currentDistace;
+
+        double arrivalTime = time;
+
+        //check if it was serviced on time
+        if (time > DueTime[end]) {
+          tardiness += time - DueTime[end];
+        }
+
+        //wait
+        double currentWaitingTime = 0.0;
+        if (time < ReadyTime[end])
+          currentWaitingTime = ReadyTime[end] - time;
+
+        double waitTime = ReadyTime[end] - time;
+
+        waitingTime += currentWaitingTime;
+        time += currentWaitingTime;
+
+        double spareTime = DueTime[end] - time;
+
+        //service
+        double currentServiceTime = ServiceTime[end];
+        serviceTime += currentServiceTime;
+        time += currentServiceTime;
+
+        CVRPTWInsertionInfo stopInfo = new CVRPTWInsertionInfo(start, end, spareCapacity, tourStartTime, arrivalTime, time, spareTime, waitTime);
+        tourInfo.AddStopInsertionInfo(stopInfo);
+      }
+
+      eval.Quality += FleetUsageFactor.Value;
+      eval.Quality += DistanceFactor.Value * distance;
+      eval.Distance += distance;
+      eval.VehicleUtilization += 1;
+
+      if (delivered > capacity) {
+        overweight = delivered - capacity;
+      }
+
+      (eval as CVRPEvaluation).Overload += overweight;
+      double tourPenalty = 0;
+      double penalty = overweight * OverloadPenalty.Value;
+      eval.Penalty += penalty;
+      eval.Quality += penalty;
+      tourPenalty += penalty;
+
+      (eval as CVRPTWEvaluation).Tardiness += tardiness;
+      (eval as CVRPTWEvaluation).TravelTime += time;
+
+      penalty = tardiness * TardinessPenalty.Value;
+      eval.Penalty += penalty;
+      eval.Quality += penalty;
+      tourPenalty += penalty;
+      eval.Quality += time * TimeFactor.Value;
+      tourInfo.Penalty = tourPenalty;
+      tourInfo.Quality = eval.Quality - originalQuality;
+
+      eval.IsFeasible = overweight == 0 && tardiness == 0;
+    }
+
+    protected override double GetTourInsertionCosts(IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+      out bool feasible) {
+      CVRPTWInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index) as CVRPTWInsertionInfo;
+
+      double costs = 0;
+      feasible = tourInsertionInfo.Penalty < double.Epsilon;
+
+      double overloadPenalty = OverloadPenalty.Value;
+      double tardinessPenalty = TardinessPenalty.Value;
+
+      double distance = GetDistance(insertionInfo.Start, insertionInfo.End, solution);
+      double newDistance =
+        GetDistance(insertionInfo.Start, customer, solution) +
+        GetDistance(customer, insertionInfo.End, solution);
+      costs += DistanceFactor.Value * (newDistance - distance);
+
+      double demand = Demand[customer];
+      if (demand > insertionInfo.SpareCapacity) {
+        feasible = false;
+        if (insertionInfo.SpareCapacity >= 0)
+          costs += (demand - insertionInfo.SpareCapacity) * overloadPenalty;
+        else
+          costs += demand * overloadPenalty;
+      }
+
+      double time = 0;
+      double tardiness = 0;
+
+      if (index > 0)
+        time = (tourInsertionInfo.GetStopInsertionInfo(index - 1) as CVRPTWInsertionInfo).LeaveTime;
+      else
+        time = insertionInfo.TourStartTime;
+
+      time += GetDistance(insertionInfo.Start, customer, solution);
+      if (time > DueTime[customer]) {
+        tardiness += time - DueTime[customer];
+      }
+      if (time < ReadyTime[customer])
+        time += ReadyTime[customer] - time;
+      time += ServiceTime[customer];
+      time += GetDistance(customer, insertionInfo.End, solution);
+
+      double additionalTime = time - (tourInsertionInfo.GetStopInsertionInfo(index) as CVRPTWInsertionInfo).ArrivalTime;
+      for (int i = index; i < tourInsertionInfo.GetStopCount(); i++) {
+        CVRPTWInsertionInfo nextStop = tourInsertionInfo.GetStopInsertionInfo(i) as CVRPTWInsertionInfo;
+
+        if (additionalTime < 0) {
+          //arrive earlier than before
+          //wait probably
+          if (nextStop.WaitingTime < 0) {
+            double wait = nextStop.WaitingTime - additionalTime;
+            if (wait > 0)
+              additionalTime += wait;
+          } else {
+            additionalTime = 0;
+          }
+
+          //check due date, decrease tardiness
+          if (nextStop.SpareTime < 0) {
+            costs += Math.Max(nextStop.SpareTime, additionalTime) * tardinessPenalty;
+          }
+        } else {
+          //arrive later than before, probably don't have to wait
+          if (nextStop.WaitingTime > 0) {
+            additionalTime -= Math.Min(additionalTime, nextStop.WaitingTime);
+          }
+
+          //check due date
+          if (nextStop.SpareTime > 0) {
+            double spare = nextStop.SpareTime - additionalTime;
+            if (spare < 0)
+              tardiness += -spare;
+          } else {
+            tardiness += additionalTime;
+          }
+        }
+      }
+
+      costs += additionalTime * TimeFactor.Value;
+
+      if (tardiness > 0) {
+        feasible = false;
+      }
+
+      costs += tardiness * tardinessPenalty;
+
+      return costs;
     }
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPProblemInstance.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPProblemInstance.cs	(revision 17710)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/SingleDepotVRP/SingleDepotVRPProblemInstance.cs	(revision 17711)
@@ -26,6 +26,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Optimization;
-using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Problems.VehicleRouting.Interfaces;
 using HeuristicLab.Problems.VehicleRouting.Variants;
@@ -35,12 +33,7 @@
   [StorableType("A45435DD-F615-45C6-8456-5A49EE5D3C8E")]
   public class SingleDepotVRPProblemInstance : VRPProblemInstance, ISingleDepotProblemInstance {
-    protected override IEnumerable<IOperator> GetOperators() {
-      return ApplicationManager.Manager.GetInstances<ISingleDepotOperator>().Cast<IOperator>();
-    }
 
-    protected override IEnumerable<IOperator> GetAnalyzers() {
-      return ApplicationManager.Manager.GetInstances<ISingleDepotOperator>()
-        .Where(o => o is IAnalyzer)
-        .Cast<IOperator>();
+    public override IEnumerable<IOperator> FilterOperators(IEnumerable<IOperator> operators) {
+      return base.FilterOperators(operators).Where(x => x is ISingleDepotOperator);
     }
 
@@ -50,16 +43,57 @@
       }
     }
+    protected override void EvaluateTour(VRPEvaluation eval, Tour tour, IVRPEncodedSolution solution) {
+      TourInsertionInfo tourInfo = new TourInsertionInfo(solution.GetVehicleAssignment(solution.GetTourIndex(tour)));
+      eval.InsertionInfo.AddTourInsertionInfo(tourInfo);
 
-    protected override IVRPEvaluator Evaluator {
-      get {
-        return new SingleDepotVRPEvaluator();
+      double distance = 0.0;
+      double quality = 0.0;
+
+      //simulate a tour, start and end at depot
+      for (int i = 0; i <= tour.Stops.Count; i++) {
+        int start = 0;
+        if (i > 0)
+          start = tour.Stops[i - 1];
+        int end = 0;
+        if (i < tour.Stops.Count)
+          end = tour.Stops[i];
+
+        //drive there
+        double currentDistace = GetDistance(start, end, solution);
+        distance += currentDistace;
+
+        StopInsertionInfo stopInfo = new StopInsertionInfo(start, end);
+        tourInfo.AddStopInsertionInfo(stopInfo);
       }
+
+      //Fleet usage
+      quality += FleetUsageFactor.Value;
+      //Distance
+      quality += DistanceFactor.Value * distance;
+
+      eval.Distance += distance;
+      eval.VehicleUtilization += 1;
+
+      tourInfo.Quality = quality;
+      eval.Quality += quality;
     }
 
-    protected override IVRPCreator Creator {
-      get {
-        return new HeuristicLab.Problems.VehicleRouting.Encodings.Alba.RandomCreator();
-      }
+    protected override double GetTourInsertionCosts(IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer,
+      out bool feasible) {
+      StopInsertionInfo insertionInfo = tourInsertionInfo.GetStopInsertionInfo(index);
+
+      double costs = 0;
+      feasible = true;
+
+      double distance = GetDistance(insertionInfo.Start, insertionInfo.End, solution);
+      double newDistance =
+        GetDistance(insertionInfo.Start, customer, solution) +
+        GetDistance(customer, insertionInfo.End, solution);
+
+      costs += DistanceFactor.Value * (newDistance - distance);
+
+      return costs;
     }
+
 
     [StorableConstructor]
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs	(revision 17710)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/ProblemInstances/VRPProblemInstance.cs	(revision 17711)
@@ -28,5 +28,4 @@
 using HeuristicLab.Data;
 using HeuristicLab.Parameters;
-using HeuristicLab.Problems.VehicleRouting.Encodings.General;
 using HeuristicLab.Problems.VehicleRouting.Interfaces;
 
@@ -35,42 +34,4 @@
   [StorableType("9A6CCE89-A4B6-4FA3-A150-181FC315B713")]
   public abstract class VRPProblemInstance : ParameterizedNamedItem, IVRPProblemInstance, IStatefulItem {
-    IVRPEvaluator moveEvaluator;
-
-    private object locker = new object();
-
-    public IVRPEvaluator MoveEvaluator {
-      get {
-        lock (locker) {
-          if (evaluator == null)
-            return null;
-          else {
-            if (moveEvaluator == null) {
-              moveEvaluator = evaluator.Clone() as IVRPEvaluator;
-
-              foreach (IParameter parameter in moveEvaluator.Parameters) {
-                if (parameter is ILookupParameter
-                  && parameter != moveEvaluator.ProblemInstanceParameter
-                  && parameter != moveEvaluator.VRPToursParameter) {
-                  (parameter as ILookupParameter).ActualName =
-                    VRPMoveEvaluator.MovePrefix +
-                    (parameter as ILookupParameter).ActualName;
-                }
-              }
-            }
-
-            return moveEvaluator;
-          }
-        }
-      }
-    }
-
-    protected abstract IEnumerable<IOperator> GetOperators();
-    protected abstract IEnumerable<IOperator> GetAnalyzers();
-
-    public IEnumerable<IOperator> Operators {
-      get {
-        return GetOperators().Union(GetAnalyzers());
-      }
-    }
 
     protected ValueParameter<DoubleMatrix> CoordinatesParameter {
@@ -131,8 +92,10 @@
     }
 
+    public virtual IEnumerable<IOperator> FilterOperators(IEnumerable<IOperator> operators) {
+      return operators.Where(x => x is IVRPOperator);
+    }
+
     protected virtual double CalculateDistance(int start, int end) {
-      double distance = 0.0;
-
-      distance =
+      var distance =
           Math.Sqrt(
             Math.Pow(Coordinates[start, 0] - Coordinates[end, 0], 2) +
@@ -172,18 +135,5 @@
     //cache for performance improvement
     private DoubleMatrix distanceMatrix = null;
-    private IVRPEvaluator evaluator = null;
-
-    public IVRPEvaluator SolutionEvaluator {
-      get {
-        return evaluator;
-      }
-      set {
-        lock (locker) {
-          moveEvaluator = null;
-          evaluator = value;
-          EvalBestKnownSolution();
-        }
-      }
-    }
+    
 
     public virtual double GetDistance(int start, int end, IVRPEncodedSolution solution) {
@@ -208,31 +158,39 @@
     }
 
-    public bool Feasible(IVRPEncodedSolution solution) {
-      return evaluator.Feasible(
-        evaluator.Evaluate(
-          this, solution));
-    }
-
-    public bool TourFeasible(Tour tour, IVRPEncodedSolution solution) {
-      return evaluator.Feasible(
-        evaluator.EvaluateTour(
-        this, tour, solution));
+    protected virtual VRPEvaluation CreateTourEvaluation() {
+      return new VRPEvaluation();
     }
 
     public VRPEvaluation Evaluate(IVRPEncodedSolution solution) {
-      return evaluator.Evaluate(this, solution);
+      VRPEvaluation evaluation = CreateTourEvaluation();
+      evaluation.IsFeasible = true;
+      foreach (Tour tour in solution.GetTours()) {
+        EvaluateTour(evaluation, tour, solution);
+      }
+      return evaluation;
     }
 
     public VRPEvaluation EvaluateTour(Tour tour, IVRPEncodedSolution solution) {
-      return evaluator.EvaluateTour(this, tour, solution);
-    }
-
-    public bool Feasible(VRPEvaluation eval) {
-      return evaluator.Feasible(eval);
+      VRPEvaluation evaluation = CreateTourEvaluation();
+      evaluation.IsFeasible = true;
+      EvaluateTour(evaluation, tour, solution);
+      return evaluation;
     }
 
     public double GetInsertionCosts(VRPEvaluation eval, IVRPEncodedSolution solution, int customer, int tour, int index, out bool feasible) {
-      return evaluator.GetInsertionCosts(this, solution, eval, customer, tour, index, out feasible);
-    }
+      bool tourFeasible;
+      double costs = GetTourInsertionCosts(
+        solution,
+        eval.InsertionInfo.GetTourInsertionInfo(tour),
+        index,
+        customer, out tourFeasible);
+
+      feasible = tourFeasible;
+
+      return costs;
+    }
+    protected abstract double GetTourInsertionCosts(IVRPEncodedSolution solution, TourInsertionInfo tourInsertionInfo, int index, int customer, out bool feasible);
+
+    protected abstract void EvaluateTour(VRPEvaluation eval, Tour tour, IVRPEncodedSolution solution);
 
 
@@ -241,10 +199,6 @@
     protected void EvalBestKnownSolution() {
       EventHandler tmp = EvaluationChanged;
-      if (tmp != null)
-        tmp(this, null);
-    }
-
-    protected abstract IVRPEvaluator Evaluator { get; }
-    protected abstract IVRPCreator Creator { get; }
+      if (tmp != null) tmp(this, null);
+    }
 
     [StorableConstructor]
@@ -262,5 +216,4 @@
       Parameters.Add(new ValueParameter<DoubleValue>("EvalDistanceFactor", "The distance factor considered in the evaluation.", new DoubleValue(1)));
 
-      evaluator = Evaluator;
       AttachEventHandlers();
     }
@@ -268,5 +221,4 @@
     protected VRPProblemInstance(VRPProblemInstance original, Cloner cloner)
       : base(original, cloner) {
-      evaluator = Evaluator;
       AttachEventHandlers();
     }
@@ -274,5 +226,4 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
-      evaluator = Evaluator;
       AttachEventHandlers();
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs	(revision 17710)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/VehicleRoutingProblem.cs	(revision 17711)
@@ -75,4 +75,6 @@
     public VehicleRoutingProblem()
       : base(new PotvinEncoding()) {
+      EncodingParameter.Hidden = false;
+
       Parameters.Add(new ValueParameter<IVRPProblemInstance>("ProblemInstance", "The VRP problem instance"));
       Parameters.Add(new OptionalValueParameter<VRPSolution>("BestKnownSolution", "The best known solution of this VRP instance."));
@@ -211,4 +213,6 @@
 
     private void InitializeOperators() {
+      Encoding.FilterOperators(ProblemInstance);
+
       Operators.Add(new VRPSimilarityCalculator());
       Operators.Add(new QualitySimilarityCalculator());
